//+------------------------------------------------------------------+
//|                                                         DEMA.mq4 |
//|                                  Copyright  2006, Amritend Maji |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Amritendu Maji"
#property link      "None"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 1
#property  indicator_color1  Blue
#property  indicator_width1  2

//---- indicator parameters
extern int Periods=30;
extern int PRICEMODE = PRICE_CLOSE;

//---- indicator buffers
double e0[];
double e1[];
double e2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,Periods);
   if(
   	!SetIndexBuffer(0,e0) &&
      !SetIndexBuffer(1,e1) &&
      !SetIndexBuffer(2,e2) 
      )
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("DEMA("+Periods+")");
//---- initialization done
   return(0);
   
  }
  
//+------------------------------------------------------------------+
//| Moving Average                                                   |
//+------------------------------------------------------------------+
int start()
  {
   int i,limit;
   int counted_bars=IndicatorCounted();
   
//---- check for possible errors
   if(counted_bars<0) return(-1);
   
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
//   limit=Bars-Periods-1-counted_bars;
   limit=Bars-counted_bars;

//---- main loop
   for(i=limit; i>=0; i--) {
   	e1[i]=iMA(NULL,0,Periods,0,MODE_EMA,PRICEMODE,i);
   }
   for(i=limit; i>=0; i--) {
   	e2[i]=iMAOnArray(e1,0,Periods,0,MODE_EMA,i);
   	e0[i]=2*e1[i] - e2[i];
   }

//---- done
   return(0);
  }
  
//+------------------------------------------------------------------+

